@echo off

rem *******************************************************
rem *                                                     *
rem *  Modul - Loader Version 3.2 for VirtualSystem       *
rem *                                                     *
rem *******************************************************

echo.
echo VSM - Loader Version 3.2 created by Ralf Woehlert
echo.

rem ***            begin fo setting DISK                   ***

 if . == .%disk% set disk=A:
 if /d == %1 goto SETDISK
 goto CHKPAR

 :SETDISK
 set disk=%2
 echo.
 echo Your basicdrive for load was set to "%disk%"
 echo. 
 goto END

rem ***            end of setting DISK                     ***



rem ***            begin of check for parameters ...       ***
:CHKPAR

 if /u == %1 goto UNLOAD
 if . == .%1 goto HELP
 if ? == %1 goto HELP
 if "/?" == "%1" goto HELP
 if /help == %1 goto HELP

rem ***            end of chheck for parameters ...        ***



rem ***            check for allready installed            ***

 if not exist v:\%1\present.tmp goto SRC000
 echo.
 echo ERROR: module "%1" cannot load once more !
 echo.
 goto END

rem ***            end of check for allready installed     ***



rem ***            check for SRC                           ***
:SRC000

 if . == .%3 goto SRC001
 set SRC=%3
 goto SRCPRS

 :SRC001
 if . == .%2 goto SRC002
 set SRC=%2
 goto SRCPRS

 :SRC002 
 set SRC=%disk%
 goto SRCPRS

rem ***            end of check for SRC                    ***



rem ***            check for SRC present                   ***
:SRCPRS

 if not exist %src%\%1\%1.??? goto SRCP001
 set SRC=%src%\%1
 goto CHKTYP

 :SRCP001
 if not exist %src%\%1.??? goto SRCP002
 goto CHKTYP

 :SRCP002
 if not exist %disk%\vsystem\modules\%1\%1.??? goto SRCP003
 set SRC=%disk%\vsystem\modules\%1
 goto CHKTYP

 :SRCP003
 if not exist %disk%\vsystem\modules\%1.??? goto SRCP004
 set SRC=%disk%\vsystem\modules
 goto CHKTYP

 :SRCP004
 echo.
 echo.
 echo Cannot find module "%1" ! 
 echo Basicdrive for load is "%disk%" .
 echo.
 goto END

rem ***            end of check for SRC present            ***



rem ***            check for type                          ***
:CHKTYP

 if exist %src%\%1.vsm goto LDVSM
 if exist %src%\%1.vsv goto LDVSV
 if exist %src%\%1.R?? goto LDRXX

 echo.
 echo.
 echo Cannot find module "%1" ! 
 echo Basicdrive for load is "%disk%" .
 echo.
 goto END

rem ***            end of check for type                   ***



rem ***            begin VSM - LOADER                      ***
:LDVSM

 echo.
 echo loading module "%1" from %src% ...
 echo.
 echo d | xcopy %src%\%1.vsm v:\tmp\~mod.exe >nul
 memdir >v:\tmp\back.bat
 xd v:\%1
 \tmp\~mod.exe
 if errorlevel 0 goto INST
 goto MELTERR
 goto END

rem ***           end of VSM - LOADER                      ***



rem ***            begin of VOLUME - LOADER                ***
:LDVSV

 echo.
 echo Volume-Set found on "%src%" !
 echo.
 echo For loading this module please remove disk from drive and put the 
 echo Volumes of the set in reverse order in drive, such as 3,2,1 ...
 echo.
 echo If you want to escape please press CTRL+C !
 echo.
 echo If you load from directory wich contains all volumes press ENTER !
 echo.
 echo If you have disks insert the last disk of the set and press ENTER !
 echo Continue in reverse order up to the first disk.
 echo.
 pause >nul

 if not exist %src%\%1.vsv goto LDRXX
 
 echo.
 echo loading part-modules of "%1" ...
 echo.
 echo d | xcopy %src%\%1.r?? v:\tmp\~mod.* >nul
 
 :LDVSV001 
 echo.
 echo loading last part of "%1" ...
 echo.
 echo d | xcopy %src%\%1.vsv v:\tmp\~mod.exe >nul
 memdir >v:\tmp\back.bat
 xd v:\%1
 \tmp\~mod.exe
 if errorlevel 0 goto INST
 goto MELTERR


:LDRXX

 echo.
 echo loading part of module "%1" ...
 echo.
 echo d | xcopy %src%\%1.r?? v:\tmp\~mod.* >nul
 
 :LDRXX001
 echo.
 echo Please insert the next disk and press ENTER !
 echo.
 pause >nul
 if exist %src%\%1.vsv goto LDVSV001
 if exist %src%\%1.r?? goto LDRXX
 goto LDRXX001
 goto END 

rem ***            end of VOLUME - LOADER                  ***



rem ***            begin of install image                  ***
:INST

 echo.
 cd v:\
 call v:\tmp\back.bat
 del v:\tmp\back.bat
 set oldpath=%path%
 set path=%path%;v:\%1
 set last=%1
 deltree /y v:\tmp\~mod.* >nul
 echo present >v:\%1\present.tmp
 echo.
 echo Module "%1" is now loaded .
 echo.
 if not exist v:\%last%\info.txt goto END
 more <v:\%last%\info.txt 
 echo.
 goto END 

rem ***            end of install image                    ***



rem ***            begin of melting error                  ***

 cd v:\
 deltree /y %1
 echo.
 echo ERROR by melting image ! 
 echo Try again or use another module !
 echo.
 call v:\tmp\back.bat
 del v:\tmp\back.bat
 goto END

rem ***            end of melting error                    ***



rem ***            begin of unload                         ***
:UNLOAD

 if . == .%last% goto UNLERR1
 if . == %oldpath% goto UNLERR2
 set path=%oldpath%
 deltree /y v:\%last%
 echo.
 echo Module "%last%" succsessfull unloaded .
 echo.
 set last=
 set oldpath=
 goto END


:UNLERR1

 echo.
 echo Cannot unload more then one module or no volumes loaded !
 echo.
 goto END

:UNLERR2
 
 echo.
 echo Unexpected ERROR unloading last module !
 echo Operation canceled . 
 echo.
 goto END

rem ***            end of unload                           ***


rem ***            begin fo help                           ***
:HELP

 echo in March, 6-st of 2002
 echo.
 echo Correct usage:
 echo                LOAD modulename [from] [src]
 echo.
 echo.
 echo The basicdrive for load is "%disk%" 
 echo.
 echo You can set the basic drive with LOAD /d newdrive (without "\" ).
 echo For unload last module use: LOAD /u or UNLOAD [last].
 echo Please report bugs to ralf@woehlert.com !
 echo.
 echo Have fun !
 echo.

goto END

rem ***            end of help                             ***



rem ***            begin of end                            ***
:END
 set SRC=

rem ***            end of end                              ***
